# Parser API

## Описание

FastAPI REST API, предоставляющий доступ к данным с сайта [Россети Ленэнерго](https://rosseti-lenenergo.ru/planned_work/).

## Доступные методы

- GET `/api/list` - Поиск по каждому полю в отдельности
- GET `/api/search` - Поиск по всем полям сразу
- GET `/api/check` - Проверка, является ли отключение в вашем доме сейчас официальным и если да, то когда сеть снова включат.
- PUT `/api/create` - Отладочное поле для добавления записей в БД
- GET `/` - Healthcheck

Подробнее: [Swagger UI](http://localhost:8000/docs) когда запущенно приложение

## Инструкция по запуску

В корневой папке проекта:

```bash
python -m venv .venv

pip install -r requirements.txt

python -m uvicorn parser_api.main:app
```